import Callable from '../../Container/Callable';
import ContextualBindingBuilder from './ContextualBindingBuilder';
import Aliaser from './Aliaser';
import Binder from './Binder';
import Extender from './Extender';
import InstanceSharer from './InstanceSharer';
import Resolver from './Resolver';
import Tagger from './Tagger';
import { Identifier, Instantiable } from '../../types/container';
interface Container extends Aliaser, Binder, Extender, InstanceSharer, Resolver, Tagger {
    unbind<U>(abstract: Identifier<U>): void;
    singleton<U, V>(abstract: Identifier<U>, concrete?: Identifier<V> | Function): void;
    when<T>(concrete: Instantiable<T>[] | Instantiable<T>): ContextualBindingBuilder;
    factory<T>(abstract: Identifier<T>): Function;
    make<T>(abstract: Identifier<T>, parameters: any[] | object): any;
    call<T>(callback: Callable<T>, parameters?: any[] | object, defaultMethod?: string): any;
    get<T>(id: Identifier<T>): any;
    set<U, V>(id: Identifier<U>, value: V): void;
    has<T>(id: Identifier<T>): boolean;
}
export default Container;
