import Callable from '../../Container/Callable';
import ContextualBindingBuilder from '../../Container/ContextualBindingBuilder';
import IAliaser from './IAliaser';
import IBinder from './IBinder';
import IExtender from './IExtender';
import IInstanceSharer from './IInstanceSharer';
import IResolver from './IResolver';
import ITagger from './ITagger';
import { Identifier, Instantiable } from '../../types/container';
interface IContainer extends IAliaser, IBinder, IExtender, IInstanceSharer, IResolver, ITagger {
    unbind<U>(abstract: Identifier<U>): void;
    singleton<U, V>(abstract: Identifier<U>, concrete?: Identifier<V> | Function): void;
    when<T>(concrete: Instantiable<T>[] | Instantiable<T>): ContextualBindingBuilder;
    factory<T>(abstract: Identifier<T>): Function;
    make<T>(abstract: Identifier<T>, parameters: any[] | object): any;
    call<T>(callback: Callable<T>, parameters?: any[] | object, defaultMethod?: string): any;
    get<T>(id: Identifier<T>): any;
    set<U, V>(id: Identifier<U>, value: V): void;
    has<T>(id: Identifier<T>): boolean;
}
export default IContainer;
