import ParameterDescriptor from '../../Descriptors/ParameterDescriptor';
import { Param } from '../../types/estree';
declare abstract class AbstractParameterAnalyser {
    protected _ast: any;
    protected _target: any;
    protected _name?: string;
    protected _types: any[];
    protected _keys?: Map<number, symbol>;
    constructor(ast: any, target: any, name?: string);
    all(): ParameterDescriptor[];
    at(index: number): ParameterDescriptor;
    private _fetchMetadata;
    private _throwError;
    protected _makeDescriptor(param: Param, type: any, position: number): ParameterDescriptor;
    protected abstract _findAssignment(param: any): any;
    private _parseAssignment;
    private _parseType;
    private _parseArrayExpression;
    private _parseObjectExpression;
    private _parseMemberExpression;
    private _parseLiteral;
}
export default AbstractParameterAnalyser;
