import { Instantiable } from '../types/container';
import { Item } from '../types/collection';
declare class Collection {
    protected _items: unknown[] | object;
    constructor(items?: unknown);
    static make<T extends Collection>(this: {
        new (items: unknown): T;
    }, items?: unknown | unknown[] | object | Collection): T;
    static wrap<T extends Collection>(this: {
        new (value: unknown): T;
    }, value: unknown): T;
    static unwrap(value: unknown | unknown[] | object | Collection): unknown[] | object;
    static times<T extends Collection>(this: {
        new (array?: unknown[]): T;
    }, number: number, callback?: Function): T;
    protected static _operatorForWhere(key: string, operator?: unknown, value?: any): Function;
    protected static _useAsCallable(value: unknown): value is Function;
    protected static _getArrayableItems(items?: any): unknown[] | object;
    protected static _valueRetriever(value?: string | Function): Function;
    private static _getArrayIterator;
    private static _getObjectIterator;
    private static _includes;
    diff(items?: unknown[] | object | Collection, callback?: Function): Collection;
    diffKeys(items?: object | Collection, callback?: Function): Collection;
    diffAssoc(items?: object | Collection): Collection;
    each(callback: Function): this;
    eachSpread(callback: Function): this;
    every(key: string | Function, operator?: unknown, value?: unknown): boolean;
    except(...keys: any[]): Collection;
    has(...keys: any[]): boolean;
    implode(value: string, glue?: string): string;
    intersect(items?: unknown[] | object | Collection): Collection;
    intersectByKeys(items?: object | Collection): Collection;
    filter(callback?: Function): Collection;
    where(key: string, operator?: unknown, value?: unknown): Collection;
    whereStrict(key: string, value: unknown): Collection;
    whereIn(key: string, values: unknown[], strict?: boolean): Collection;
    whereInStrict(key: string, values: unknown[]): Collection;
    whereBetween(key: string, values: unknown[]): Collection;
    whereNotIn(key: string, values: unknown[], strict?: boolean): Collection;
    whereNotInStrict(key: string, values: unknown[]): Collection;
    whereInstanceOf<T>(type: Instantiable<T>): Collection;
    all(): any;
    avg(callback?: Function | string): number | undefined;
    average(callback?: Function | string): number | undefined;
    collapse(): Collection;
    some(key: unknown, operator?: unknown, value?: unknown): boolean;
    contains(key: unknown, operator?: unknown, value?: unknown): boolean;
    containsStrict(key: any, value?: unknown): boolean;
    crossJoin(...lists: unknown[]): Collection;
    first(callback?: Function | null, dflt?: unknown): unknown;
    firstWhere(key: string, operator: string, value?: unknown): unknown;
    flatten(depth?: number): Collection;
    flip(): Collection;
    forget(keys: string | number | (string | number)[]): this;
    keys(): Collection;
    last(callback?: Function | null, dflt?: unknown): unknown;
    pluck(value: string | string[], key?: string): Collection;
    map(callback: Function): Collection;
    mapSpread(callback: Function): Collection;
    mapToDictionary(callback: Function): Collection;
    mapToGroups(callback: Function): Collection;
    mapWithKeys(callback: Function): Collection;
    flatMap(callback: Function): Collection;
    mapInto(target: any): Collection;
    max(callback?: Function | string): unknown;
    merge(items?: unknown[] | object | Collection): Collection;
    combine(values: unknown[] | object | Collection): Collection;
    union(items?: unknown[] | object | Collection): Collection;
    min(callback?: Function | string): unknown;
    nth(step: number, offset?: number): Collection;
    only(...keys: any): Collection;
    forPage(page: number, perPage: number): Collection;
    transform(callback: Function): this;
    unique(key?: string | Function, strict?: boolean): Collection;
    uniqueStrict(key?: string | Function): Collection;
    pipe(callback: Function): unknown;
    pop(): unknown;
    prepend(value: unknown, key?: string): this;
    push(value: unknown | Item): this;
    concat(source: unknown[] | object | Collection): Collection;
    pull(key: string | number, dflt?: unknown): unknown;
    put(key: string | number | null, value: unknown): this;
    random(number?: number): any;
    reduce(callback: any, initial?: unknown): any;
    reject(callback: unknown | Function): Collection;
    isEmpty(): boolean;
    isNotEmpty(): boolean;
    reverse(): Collection;
    search(value: Function | unknown, strict?: boolean): number | string | boolean;
    shift(): unknown;
    shuffle(seed?: string): Collection;
    slice(offset: number, length?: number): Collection;
    split(numberOfGroups: number): Collection;
    chunk(size: number): Collection;
    sort(callback?: (a: any, b: any) => number): Collection;
    sortBy(callback: Function | string, descending?: boolean): Collection;
    sortByDesc(callback: Function | string): Collection;
    sortKeys(descending?: boolean): Collection;
    sortKeysDesc(): Collection;
    splice(offset: number, length?: number, replacement?: unknown[] | unknown): Collection;
    sum(callback?: Function | string): number;
    take(limit: number): Collection;
    get(key: number | string, dflt?: unknown): any;
    groupBy(groupBy: [string, Function] | [Function] | Function | string, preserveKeys?: boolean): Collection;
    keyBy(keyBy: Function | string): Collection;
    offsetExists(key: number | string): boolean;
    offsetGet(key: number | string): unknown;
    offsetSet(key: string | number | null, value: unknown): void;
    values(): Collection;
    zip(...items: any[]): Collection;
    pad(size: number, value: unknown): Collection;
    toPrimitive(): unknown[] | object;
    jsonSerialize(): unknown[];
    getIterator(): IterableIterator<unknown>;
    count(): number;
    private _shallowCopy;
    private _loop;
    private _values;
}
export default Collection;
